commit 0e174fbc0468c138a61ad1acb8952f7cdaef2a86
Author: freddy77 <freddy77>
Date:   Tue Jan 26 11:10:51 2010 +0000

    allow driver registration like ole controls

diff --git a/ChangeLog b/ChangeLog
index ae1d77e..393ca21 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Jan 26 12:09:58 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* win32/FreeTDS.def win32/winsetup.c:
+	- allow driver registration like ole controls
+
 Tue Jan 26 00:06:54 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/Makefile.am: fix windows build out of directory
 
@@ -2181,4 +2185,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2953 2010/01/25 23:06:59 freddy77 Exp $
+$Id: ChangeLog,v 1.2954 2010/01/26 11:10:51 freddy77 Exp $
diff --git a/win32/FreeTDS.def b/win32/FreeTDS.def
index 15994f6..11b898f 100644
--- a/win32/FreeTDS.def
+++ b/win32/FreeTDS.def
@@ -76,3 +76,5 @@ EXPORTS
 	ConfigDSN
 	ConfigDriver
 	ConfigTranslator
+	DllRegisterServer
+	DllUnregisterServer
diff --git a/win32/winsetup.c b/win32/winsetup.c
index ea233f1..8a0b26f 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -50,6 +50,7 @@
 #include <assert.h>
 #include <ctype.h>
 #include <assert.h>
+#include <olectl.h>
 
 #include "resource.h"
 
@@ -57,6 +58,7 @@
 #include "tdsodbc.h"
 #include "tdsstring.h"
 #include "tdsconvert.h"
+#include "replacements.h"
 
 #ifdef DMALLOC
 #include <dmalloc.h>
@@ -415,3 +417,49 @@ ConfigTranslator(HWND hwndParent, DWORD * pvOption)
 {
 	return TRUE;
 }
+
+HRESULT WINAPI
+DllRegisterServer(void)
+{
+	TCHAR fn[MAX_PATH], full_fn[MAX_PATH];
+	LPTSTR name;
+	WORD len_out;
+	DWORD cnt;
+	char *desc = NULL;
+	BOOL b_res;
+
+	if (!GetModuleFileName(hinstFreeTDS, fn, TDS_VECTOR_SIZE(fn)))
+		return SELFREG_E_CLASS;
+	if (!GetFullPathName(fn, TDS_VECTOR_SIZE(full_fn), full_fn, &name) || !name || full_fn == name)
+		return SELFREG_E_CLASS;
+
+	if (asprintf(&desc, "FreeTDS%c"
+		"APILevel=2%c"
+		"ConnectFunctions=YYN%c"
+		"DriverODBCVer=03.00%c"
+		"FileUsage=0%c"
+		"SQLLevel=2%c"
+		"Setup=%s%c"
+		"Driver=%s%c",
+		0, 0, 0, 0, 0, 0,
+		name, 0, name, 0
+		) < 0)
+		return SELFREG_E_CLASS;
+	name[-1] = 0;
+
+	b_res = SQLInstallDriverEx(desc, full_fn, fn, TDS_VECTOR_SIZE(fn), &len_out, ODBC_INSTALL_COMPLETE, &cnt);
+	free(desc);
+	if (!b_res)
+		return SELFREG_E_CLASS;
+	return S_OK;
+}
+
+HRESULT WINAPI
+DllUnregisterServer(void)
+{
+	DWORD cnt;
+	if (!SQLRemoveDriver("FreeTDS", FALSE, &cnt))
+		return SELFREG_E_CLASS;
+	return S_OK;
+}
+

